<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Platform\Api\Mall;

use Platform\Common\Api;
use Mall\Domain\Product;
use Mall\Domain\Order;
use Mall\Domain\Config;
use Mall\Domain\Flow;
use Mall\Domain\Pay;
use PhalApi\Exception\BadRequestException;

/**
 * 商城模块
 */
class Mall extends Api {

    public function getRules() {
        return array(
            'previewOrder' => array(
                'product_id' => array('name' => 'product_id', 'require' => true, 'type' => 'int', 'min' => 1, 'desc' => '产品套餐ID'),
                'num' => array('name' => 'num', 'type' => 'int', 'min' => 1, 'default' => 1, 'desc' => '购买数量'),
            ),
            'createOrder' => array(
                'product_id' => array('name' => 'product_id', 'require' => true, 'type' => 'int', 'min' => 1, 'desc' => '产品套餐ID'),
                'num' => array('name' => 'num', 'type' => 'int', 'min' => 1, 'default' => 1, 'desc' => '购买数量'),
                'note' => array('name' => 'note', 'default' => '', 'desc' => '买家备注'),
            ),
            'getMyFlowList' => array(
                'page' => array('name' => 'page', 'type' => 'int', 'default' => 1,  'desc' => '当前页数'),
                'perpage' => array('name' => 'perpage', 'type' => 'int', 'default' => 10, 'desc' => '每页多少条'),
            ),
            'getMyOrderList' => array(
                'page' => array('name' => 'page', 'type' => 'int', 'default' => 1,  'desc' => '当前页数'),
                'perpage' => array('name' => 'perpage', 'type' => 'int', 'default' => 10, 'desc' => '每页多少条'),
            ),
            'previewPay' => array(
                'order_id' => array('name' => 'order_id', 'require' => true, 'desc' => '订单号'),
            ),
            'startPay' => array(
                'order_id' => array('name' => 'order_id', 'require' => true, 'desc' => '订单号'),
                'pay_type' => array('name' => 'pay_type', 'desc' => '支付方式，未传时使用订单原来的支付方式'),
            ),
            'paySuccess' => array(
                'order_id' => array('name' => 'order_id', 'require' => true, 'desc' => '订单号'),
            ),
        );
    }

    /**
     * 准备下单
     * @desc 订单预览
     * @return object product 商品信息
     * @return double price 订单总价
     */
    public function previewOrder() {
        $domain = new Product();
        $product = $domain->getAvailableProduct($this->product_id);

        if (!$product) {
            throw new BadRequestException(\PhalApi\T('product not exists'));
        }

        $price = floatval($product['price']) * $this->num;

        // 相同类型的产品套餐
        $other_product_list = $domain->getOtherProductList($this->product_id);

        $order_amount_list_config = \PhalApi\DI()->config->get('mall.order_amount_list');
        $order_amount_list = array();
        foreach ($order_amount_list_config as $key => $val) {
            $order_amount_list[] = array('key' => $key, 'name' => $val);
        }

        return array('product' => $product, 'price' => $price, 'num' => $this->num, 'other_product_list' => $other_product_list, 'order_amount_list' => $order_amount_list);
    }

    /**
     * 创建订单
     * @desc 创建订单
     * @return string order_id 订单号，失败时为null
     */
    public function createOrder() {
        $orderDomain = new Order();
        $order_id = $orderDomain->createOrder($this->product_id, $this->num, $this->note);
        return array('order_id' => $order_id);
    }

    /**
     * 在线支付
     * @desc 准备在线支付
     */
    public function previewPay() {
        $orderDomain = new Order();
        $order = $orderDomain->getOrderInfo($this->order_id);

        $configDomain = new Config();
        $pay_list = $configDomain->getPayList();

        return array('order_info' => $order, 'pay_list' => $pay_list);
    }

    /**
     * 开始支付
     * @desc 开始在线支付
     */
    public function startPay() {
        $payDomain = new Pay();
        $pay_result = $payDomain->startPay($this->order_id, $this->pay_type);

        return array('pay_result' => $pay_result);
    }

    /**
     * 支付成功
     * @desc 支付成功
     * @return bool is_pay 是否支付成功，true/false
     */
    public function paySuccess() {
        $orderDomain = new Order();
        $is_pay = $orderDomain->checkOrderPay($this->order_id);
        return array('is_pay' => $is_pay);
    }

    /**
     * 获取我的流量套餐
     * @desc 获取我的流量套餐
     * @return int   total   总条数
     * @return int   page    当前页数
     * @return int   perpage 每页条数
     * @return array items   计划任务数据
     * @return int items.id  id
     */
    public function getMyFlowList() {
        $domain = new Flow();
        return $domain->getMyFlowList($this->page, $this->perpage);
    }

    /**
     * 获取我的订单列表
     * @desc 获取我的订单列表
     * @return int   total   总条数
     * @return int   page    当前页数
     * @return int   perpage 每页条数
     * @return array items   计划任务数据
     * @return int items.id  id
     */
    public function getMyOrderList() {
        $domain = new Order();
        return $domain->getMyOrderList($this->page, $this->perpage);
    }

    /**
     * 获取组合套餐
     * @desc 获取组合套餐
     * @return int   total   总条数
     * @return array items   计划任务数据
     */
    public function getProductMoreList() {
        $domain = new Product();
        return $domain->getProductMoreList();
    }

}
